;
; channel15.asm - channel 15 command execution
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
OP_XIT_do_command_channel .proc

		#xit_init

		#ldatax buffer_currentp_exp
		lda buffer_address_low_exp,x
		bne oknoy
		rts
rr		jmp LWOP_reporterror_32_xit;-=> buffer overflow

oknoy		cmp #255
		bcs rr			;buffer overflow
		pha
		#lda0
		sta buffer_address_low_exp,x
		sta pom1
		lda buffer_start,x
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi
		#ply_a
		dey
		#lda_zp_y pom1
		eor #13			;remove trailing CR
		beq *+3
		iny

		#lda0			;trailing zero
		.byte SKIP2

thnu		#lda_zp_y pom1		;copy from buffer to path
		#sta_l_y_x path_exp
		dey
		cpy #255
		bne thnu

OP_XIT_execute_15command_open .proc

		lda buffer_drive_exp,x
		sta current_drive_exp

		#xit_init

		jsr check_drive		;check drive is alive

		lda path_exp
		ldx #commandslo-commands
htnuo		cmp commands-1,x
		bne njooocmd
		lda commandshi-1,x
		pha
		lda commandslo-1,x
		pha
		lda path_exp+1
		rts

njooocmd	dex
		bne htnuo

cmdnotimp	.proc
		sec
		gcs LWOP_reporterror_31_xit;Unknown command
		.pend

cmdsynterr	.proc
		sec
		gcs LWOP_reporterror_30_xit;Command syntax
		.pend
;-------------------------------
;I
;
cmd_i		.proc
		jmp OP_XIT_init_filesystem_from_disk
		.pend
;-------------------------------
;U
;
cmd_user	.proc
		cmp #"0"
		beq usercmd0
		and #15
		cmp #9
		beq usercmd9
		cmp #10
		beq usercmdreset
		gne cmdnotimp
		.pend
;-------------------------------
;UI/U9
;
usercmd9	.proc
		ldx #0
		ldy #0
		jmp LWOP_reporterror_73_xit
		.pend
;-------------------------------
;UJ/U:
;
usercmdreset	.proc
		lda current_drive_exp
		jsr OP_hdinit
		lda current_drive_exp
		jmp OP_XIT_hdinit_2
		.pend
;-------------------------------
;U0>
;
usercmd0	.proc
		lda path_exp+2
		cmp #">"
		bne cmdsynterr
		lda path_exp+3
		cmp #31			;"U0>"+CHR$(<drivenumber>)
		bcs usercmdnnumber
		#ldx_l_ current_drive_exp
		cmp #0			;Disable drive
		beq tnstns
		sta current_drivenumbers_exp,x
		jmp LWOP_reporterror_ok
tnstns		sta drive_type_exp,x
		geq cmdusercmddisab	;Power down disabled drive
		.pend
;-------------------------------
;U0>P
;
usercmdnnumber	.proc
		cmp #"P"		;"U0>P"+CHR$(<powermode>)
		bne usercmdnp
		jsr head_select_drive
		lda path_exp+4
		lsr
		bcc cmdusercmddisab
		lda #idle_imediate1_d
		jsr ata_command
		bcc cmdusercmddisab.ok
		lda #idle_imediate2_d
		gcs cmdusercmddisab.be
cmdusercmddisab	.proc
		lda #standby_now1_d
		jsr ata_command
		bcc ok
		lda #standby_now2_d
be		jsr ata_command
		jsr LWOP_reporterror_xit
ok		jmp LWOP_reporterror_ok
		.pend

;-------------------------------
;U0>E
;
usercmdnp	.proc
		cmp #"E"		;"U0>E"+CHR$(<mode>)
		bne usercmdne
		jsr XIT_init_drive2
		lda #ATAPI_CMD_START_STOP
		jsr OP_atapi_packet
		lda path_exp+4
		and #1
		eor #3
                gne usercmdne.in
;-------------------------------
;U0>L
;
usercmdne	.proc
		cmp #"L"		;"U0>L"+CHR$(<mode>)
		bne usercmdnl
		jsr XIT_init_drive2
		lda #ATAPI_CMD_LOCK_UNLOCK
		jsr OP_atapi_packet
		lda path_exp+4
		and #1
in		#pw 4
		jsr OP_atapi_command
		jsr LWOP_reporterror_xit
		jmp LWOP_reporterror_ok
		.pend
;-------------------------------
;U0>A
;
usercmdnl	.proc
		cmp #"A"		;"U0>A"+CHR$(M)+CHR$(S)+CHR$(F)+CHR$(M)+CHR$(S)+CHR$(F)
		bne cmdnotimp
		jsr XIT_init_drive2
		lda #ATAPI_PLAY_AUDIO_MSF
		jsr OP_atapi_packet
		lda path_exp+4
		#pw 3
		lda path_exp+5
		#pw 4
		lda path_exp+6
		#pw 5
		lda path_exp+7
		#pw 6
		lda path_exp+8
		#pw 7
		lda path_exp+9
		#pw 8
		jsr OP_atapi_command
		jsr LWOP_reporterror_xit
		jmp LWOP_reporterror_ok
		.pend
;-------------------------------
;C
;
cmd_c		.proc

		cmp #128+"P"
		bne cmd_cp
		jsr XIT_init_drive	;cP
		lda path_exp+2
in		jsr OP_XIT_check_partition_selection;-=> error
		#ldx_l_ current_drive_exp
		sta drive_workpartition_exp,x
		adc #1
		tax
		ldy #0
		jmp LWOP_reporterror_02_xit
		.pend
;-------------------------------
;CP
;
cmd_cp		.proc
		cmp #"P"
		bne cmd_cd
		jsr OP_short_path
		jsr OP_short_path
		ldx #255
gc		inx
		lda path_exp,x
		bne gc
		sta path_exp+1,x	;hack ;)
		lda #":"
		sta path_exp,x

		jsr XIT_init_drive
		jsr OP_get_partnum
		lda path_partition_exp
		jmp cmd_c.in
		.pend
;-------------------------------
;CD
;
cmd_cd		.proc
		jsr OP_short_path	;eat "C"
		cmp #"D"		;CD hack ;)
		bne ide64
		jsr OP_short_path	;eat "D"
		cmp #95
		bne rp
		lda path_exp+1
		bne rp			;eol?

pphack		sta path_exp+2
		lda #"."
		sta path_exp
		sta path_exp+1
		gne cmd_cd2.in

rp		jsr OP_delimiter_in_path
		php
		jsr OP_get_partnum	;eat number
                plp
                bcs cmd_cd2.in

		lda path_exp
		cmp #95
		bne bs
		jsr OP_short_path	;eat "<-"
		beq pphack		;CD<-
                #lda0			;error

bs	     	eor #"/"		;CD/
		cmp #1
                jsr LWOP_reporterror_30_xit;-=> error
                jsr OP_short_path	;eat "/"
                #jmps cmd_cd2.in

ide64		jsr OP_XIT_partnum_delimiter;-=> error
		jmp cmd_cd2.in

cmd_cd2		.proc
		jsr OP_short_path
		jsr OP_get_partnum
		lda path_exp
		bne in
		sta path_exp+1
		lda #"/"		;root dir hack
		sta path_exp
in		jsr XIT_init_drive	;-=> error
		lda #RESOLV_CD_MODE
		jsr OP_XIT_resolv_path	;-=> path
                jsr LWOP_reporterror_39_xit;-=> error

		#ldatax partition_currentp_exp

		ldy #0
bnmf		lda next_sector,y
		sta partition_workdir_exp,x
		inx
		iny
		cpy #4
		bne bnmf
		geq LWOP_reporterror_ok
		.pend
;-------------------------------
;S
;
cmd_s		.proc
		jsr OP_short_path
		jsr OP_XIT_partnum_delimiter;-=> error

		jsr XIT_init_drive	;-=> error
		lda #RESOLV_S_MODE
		jsr OP_XIT_resolv_path	;-=> path

		lda resolv_anything_exp
		sec
		beq LWOP_reporterror_34_xit;-=> no filename

		#ldatax partition_currentp_exp
		lda partition_start_exp,x
		and #PATTR_WRITEABLE
		bne *+5
wp		jmp LWOP_reporterror_26_xit;write protected

		lda direntry_f_attrib_exp
		and #FATTR_DELETE | FTYPE_MASK
		eor #FATTR_DELETE | FTYPE_NORMAL
		bne wp			; other type not done yet

		ldx #3
lsd		lda next_sector,x	;#cnext next_sector , ram_exp_buffer0b_exp
		sta ram_exp_buffer0b_exp,x
		lda resolv_this_sector_exp,x
		sta next_sector,x	;#cnext resolv_this_sector_exp , next_sector
		dex
		bpl lsd

		lda #ram_exp_buffer0
		jsr XIT_read_a_sector

		lda resolv_entry_offs_exp
		lsr
		ror
		ror
		ror
		sta pom1
		lda #ram_exp_buffer0
		adc #0
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi

		ldy #$18		;filetype exp
		#lda_zp_y pom1
		and #<~(FTYPE_MASK | FATTR_CLOSED)
		#sta_zp_y pom1

		lda #ram_exp_buffer0
		jsr XIT_write_a_sector	;first kill entry, than free space

		lda direntry_f_attrib_exp
		bpl nono		;not closed file, so no freeing ;(

		#ldatax partition_currentp_exp
		lda partition_root_dir_exp,x
		asl
		#lda0
		tay
		rol
		sta scratch_bam_exp

lq2		lda partition_start_exp,x
		sta next_sector,y
		inx
		iny
		cpy #4
		bne lq2

		jsr chs2lba

		ldx #3
ll		lda szam,x
		sta scratch_startpart_exp,x
		lda #255
		sta scratch_now_exp,x
		dex
		bpl ll

		lda #3
		sta scratch_sp_exp
rec_free
		ldy #3
		#ldatax scratch_sp_exp
		cmp #255
		bne ls
		jsr flush
nono		ldx #1
		ldy #0
		jmp LWOP_reporterror_01_xit

ls		lda ram_exp_buffer0b_exp,x
		sta next_sector,y
		dex
		dey
		bpl ls
		#stx_l_a scratch_sp_exp

		lda #ram_exp_tree
		jsr XIT_read_a_sector

		lda #255
		sta scratch_p_exp
		gne in			;free tree sector too

slp		lda scratch_p_exp
		asl
		asl
		sta pom1
		lda #ram_exp_tree
		adc #0
		sta pom2
		.if SUPERCPU=1
		lda #1
		sta pom3
		.fi

		clc
		ldy #3
lw		#lda_zp_y pom1
		beq *+3
		sec
		sta next_sector,y
		dey
		bpl lw
		bcc null

in		jsr chs2lba

		lda szam+0
		sec
		sbc scratch_startpart_exp+0
		pha
		#stz_a szam+0
		lda szam+1
		sbc scratch_startpart_exp+1
		pha
		and #$f0
		sta szam+1
		lda szam+2
		sbc scratch_startpart_exp+2
		sta szam+2
		lda szam+3
		sbc scratch_startpart_exp+3
		sta szam+3

		ldx #3
ce		lda szam,x
		cmp scratch_now_exp,x
		bne vw
		dex
		bne ce
		geq ncw

vw		jsr flush

		ldx #0
		lda scratch_bam_exp
		lsr
		ldy #3
li		lda szam,x
		adc scratch_startpart_exp,x
		sta szam,x
		inx
		dey
		bpl li

		jsr lba2chs

		#cnext next_sector , scratch_now_bam_exp

		lda #ram_exp_bitmap
		jsr XIT_read_a_sector

ncw		pla
		and #$0f
		sta pom2
		pla
		tay
		and #7
		tax
		tya

		lsr pom2
		ror
		lsr pom2
		ror
		lsr pom2
		ror
		sta pom1
		lda pom2
		ora #ram_exp_bitmap
		sta pom2
		.if SUPERCPU=1
		ldy #1
		sty pom3
		dey
		.else
		ldy #0
		.fi

		#lda_zp_y pom1
		ora bm,x
		#sta_zp_y pom1

null		#inc_l_a scratch_p_exp
		bpl slp

		ldy #0
		sty current_path
		lda #ram_exp_tree
		sta current_path+1
		.if SUPERCPU=1
		lda #1
		sta current_path+2
		.fi

		lda #8
		sta pom1

ns		ldx #3
mi		#lda_zp_y current_path
		asl
		asl
		asl
		rol next_sector,x
		asl
		rol next_sector,x
		tya
		clc
		adc #4
		tay
		and #15
		bne mi
		dex
		bpl mi
		bcc *+4
		inc current_path+1

		lda next_sector
		ora next_sector+1
		ora next_sector+2
		ora next_sector+3
		beq sm

		#phy_a
		lda scratch_sp_exp
		clc
		adc #4
		sta scratch_sp_exp
		tax
		ldy #3
mr		lda next_sector,y
		sta ram_exp_buffer0b_exp,x
		dex
		dey
		bpl mr
		#ply_a

sm		dec pom1
		bne ns

		jmp rec_free

flush		lda scratch_now_exp
		bmi bf

		#cnext scratch_now_bam_exp , next_sector

		lda #ram_exp_bitmap
		jsr XIT_write_a_sector

bf		#cnext szam , scratch_now_exp
		rts

bm		.byte %10000000
		.byte %01000000
		.byte %00100000
		.byte %00010000
		.byte %00001000
		.byte %00000100
		.byte %00000010
		.byte %00000001
		.pend

;-------------------------------
;B block commands
;
cmd_b		.proc
		lda path_exp+1
		cmp #"="
		bne err
		lda path_exp+2
		cmp #"R"
		bne nread
		jsr blockc
		pha
		ldx #3
vt		lda next_sector,x
		bne noident
		dex
		bpl vt
		jsr OP_get_current_drive_type
		asl
		lda #ident_d
		bcc *+4
		lda #atapi_ident_d
		jsr ata_data_command
		jsr LWOP_reporterror_read_xit;-=> error
		pla
		jsr OP_read512_here
		jsr ata_pi_nomore_data
		jsr LWOP_reporterror_read_xit
		jmp LWOP_reporterror_ok

noident		jsr XIT_init_drive2
		pla
		jsr XIT_read_a_sector2
		jmp LWOP_reporterror_ok

nread		cmp #"W"
		bne nwrite
		jsr blockc
		pha
		lda direct_write_exp
		sec
		beq LWOP_reporterror_26_xit
		jsr XIT_init_drive2
		pla
		jsr XIT_write_a_sector2
		jmp LWOP_reporterror_ok

nwrite		cmp #"P"
		bne err
		jsr chnl
		lda path_exp+4
		sec
		sbc #1
		sta buffer_address_low_exp,x
		php
		lda buffer_address_max_hi_exp,x
		clc
		sbc buffer_start,x
		plp
		and path_exp+5
		sbc #0
		clc
		adc buffer_start,x
		sta buffer_address_hi_exp,x
		jmp LWOP_reporterror_ok

err		sec
		gcs LWOP_reporterror_31_xit
err2		sec
		gcs LWOP_reporterror_70_xit


chnl		lda path_exp+3
		jsr search_channel_A
		bne err2
		lda buffer_type_exp,x
		cmp #BUFFERMODE_DIRECT
		bne err2
		rts

blockc		jsr chnl
		#cnext path_exp+4 , next_sector
		jsr OP_init_buffer_pointers
		lda buffer_start,x
		rts
		.pend
;-------------------------------
;P position
;
cmd_p		.proc
		lda path_exp+1
		jsr search_channel_A
		bne err2
		lda buffer_type_exp,x
		cmp #BUFFERMODE_FILE
		bne err2

		ldy #stateless-statenow
ver		lda buffer_info_exp,x
		eor statenow-1,y
		beq vy
		dey
		bne ver
err2		sec
		gcs LWOP_reporterror_70_xit

vy		lda #INFO_IGNORE	;be safe
		sta buffer_info_exp,x

		lda statewhat-1,y
		bpl vdrs

		#phy_a
		jsr update_filelen
		jsr XIT_flush_buf
		#ldatax buffer_currentp_exp
		#ply_a
vdrs
		lda buffer_filesize1_exp,x
		cmp path_exp+2
		lda buffer_filesize2_exp,x
		sbc path_exp+3
		lda buffer_filesize3_exp,x
		sbc path_exp+4
		lda buffer_filesize4_exp,x
		sbc path_exp+5

		lda stateless-1,y
		bcs less
		lda stateend-1,y
less		pha

		lda path_exp+3
		and #%11111110
		sta buffer_filepos2_exp,x
		lda path_exp+4
		sta buffer_filepos3_exp,x
		lda path_exp+5
		sta buffer_filepos4_exp,x

		#lda0
		sta buffer_address_end_hi_exp,x
		sta buffer_address_end_low_exp,x

		lda path_exp+3
		and #1
		ora path_exp+2
		beq m512

		#phy_a
		jsr XIT_init_drive	;-=> error
		pla
		beq rrd
		jsr XIT_save_tree	;-=> error
		#jmps tr
rrd		jsr XIT_load_tree	;-=> error

tr		jsr XIT_read_in_buffer

		#ldatax buffer_currentp_exp
		lda buffer_start,x
		ora #2
		sta buffer_address_end_hi_exp,x
		#lda0
		sta buffer_address_end_low_exp,x

		lda buffer_filesize1_exp,x
		sec
		sbc #1
		sta pom1
		lda buffer_filesize2_exp,x
		sbc buffer_filepos2_exp,x
		sta pom2
		lda buffer_filesize3_exp,x
		sbc buffer_filepos3_exp,x
		sta pom3
		lda buffer_filesize4_exp,x
		sbc buffer_filepos4_exp,x
		ora pom3
		bne m512
		lsr pom2
		bne m512

		lda buffer_start,x
		adc #0
		sta buffer_address_end_hi_exp,x
		lda pom1
		sta buffer_address_end_low_exp,x
m512

		lda path_exp+2
		sec
		sbc #1
		sta buffer_address_low_exp,x
		lda path_exp+3
		and #1
		sbc #0
		clc
		adc buffer_start,x
		cmp buffer_address_end_hi_exp,x
		bne *+4
		ora #$80
		sta buffer_address_hi_exp,x

		pla
		sta buffer_info_exp,x
		jmp LWOP_reporterror_ok

statenow	.byte INFO_BLK_READ ,INFO_BLK_R_EOF,INFO_BLK_WRITE,INFO_BLK_WRITE_DIRTY,INFO_BLK_RW    ,INFO_BLK_RW_EOF,INFO_BLK_RW_DIRTY,INFO_BLK_RW_EOF_DIRTY
stateless	.byte INFO_BLK_READ ,INFO_BLK_READ ,INFO_BLK_WRITE,INFO_BLK_WRITE      ,INFO_BLK_RW    ,INFO_BLK_RW    ,INFO_BLK_RW      ,INFO_BLK_RW
stateend	.byte INFO_BLK_R_EOF,INFO_BLK_R_EOF,INFO_BLK_WRITE,INFO_BLK_WRITE      ,INFO_BLK_RW_EOF,INFO_BLK_RW_EOF,INFO_BLK_RW_EOF  ,INFO_BLK_RW_EOF
statewhat	.byte 0             ,0             ,1             ,128                 ,1              ,1              ,128              ,128
		.pend
;-------------------------------
;M make dir
;
cmd_m		.proc
		jsr OP_short_path
		cmp #"D"		;MD hack ;)
		bne ide64
		jsr OP_short_path
ide64
		jsr OP_XIT_partnum_delimiter;-=> error

		jsr XIT_init_drive	;-=> error

		lda #RESOLV_MD_MODE
		jsr OP_XIT_resolv_path_part;-=> error
		bcs jo
		sec
		gcs LWOP_reporterror_63_xit;-=> file exists
jo
		#lda0
		sta path_searchtype_exp
		lda #ram_exp_bitmap
		jsr XIT_prealloc_dir_sector;-=> error

		jsr find_free_sector	;allocate dir sector

		#cnext next_sector , created_new_dir_sector_exp

		ldx #0
		txa
nw		sta ram_exp_buffer0b_exp,x
		sta ram_exp_buffer0b_exp+$100,x
		inx
		bne nw

		tay
		tax
ii2		#lda_l_y_ path_exp	;fill in filename
		beq vt
		iny
		.byte SKIP2
vt		lda #32
		sta ram_exp_buffer0b_exp,x
		inx
		cpx #16
		bne ii2

		ldx #3
ns		lda next_sector,x
		sta ram_exp_buffer0b_exp+$10,x
		lda resolv_this_dir_exp,x
		sta ram_exp_buffer0b_exp+$14,x
		lda cdir,x
		sta ram_exp_buffer0b_exp+$18,x
		#lda0
		sta ram_exp_buffer0b_exp+$1c,x
		dex
		bpl ns

		lda #ram_exp_buffer0b	;write out dir sector
		jsr XIT_write_a_sector	;-=> error

		jsr XIT_find_free_flush	;-=> error

		lda #ram_exp_buffer0
		jsr init_pom1_y

		ldx #2
sw		lda cdir+1,x
		sta path_searchtype_exp,x
		#lda0
		sta szam,x
		dex
		bpl sw
		sta szam+3

		lda #FTYPE_DIR | FATTR_EXEC | FATTR_READ | FATTR_WRITE | FATTR_DELETE | FATTR_CLOSED
		jsr XIT_finalize_direntry

		lda #ram_exp_buffer0	;write out the final directory entry
		jsr XIT_write_a_sector	;-=> error

		jmp LWOP_reporterror_ok

cdir		.byte FTYPE_DIR | FATTR_EXEC | FATTR_READ | FATTR_WRITE | FATTR_DELETE,"D","I","R"
		.pend


search_channel_A .proc
		ora #$60
		sta pom2
		#ldatax buffer_currentp_exp;channel 15's buffer
		lda buffer_logical_exp,x
		ldx #MAX_OPEN_FILES
lp		dex
		bmi exit
		cmp open_files_logical_exp,x
		bne lp
		lda open_files_device_exp,x;now we have the drivenumber we are on
		sta pom1
		ldx #MAX_OPEN_FILES
lp2		dex
		bmi exit
		lda pom1
		cmp open_files_device_exp,x;on this drive?
		bne lp2
		lda pom2
		cmp open_files_secondary_exp,x;channel correct?
		bne lp2
		lda open_files_logical_exp,x;file open?
		beq lp2
		gne search_buffer_A
exit		rts
		.pend

commands	.text "UCI/SBPM"
commandslo	.byte <(cmd_user-1)
		.byte <(cmd_c-1)
		.byte <(cmd_i-1)
		.byte <(cmd_cd2-1)
		.byte <(cmd_s-1)
		.byte <(cmd_b-1)
		.byte <(cmd_p-1)
		.byte <(cmd_m-1)
commandshi	.byte >(cmd_user-1)
		.byte >(cmd_c-1)
		.byte >(cmd_i-1)
		.byte >(cmd_cd2-1)
		.byte >(cmd_s-1)
		.byte >(cmd_b-1)
		.byte >(cmd_p-1)
		.byte >(cmd_m-1)
